=============================================
Introdution to Pilotis IO library
=============================================

.. image:: https://gitlab.com/ekinox-io/ekinox-libraries/ekinox-python-library-for-jacc/badges/master/pipeline.svg
    :target: https://gitlab.com/ekinox-io/ekinox-libraries/ekinox-python-library-for-jacc/pipelines

This is a lib with common functions to use while coding Python ML projects to deal with IO.

* Free software license: MIT

Features
--------

Deal with a file system
=======================

The abstract class `pilotis_io.io.IoAPI` defines all functions needed to interact with a file system for data projects.
There are currently 2 implementations :

- `pilotis_io.local.local_io_api.LocalIoApi`: this class could be used to deal with a local file system.
- `pilotis_io.s3.s3_io_api.S3IoAPI`: this class could be used to deal with files stored in an S3 bucket.

Opinionated directory structure
===============================

There should be a shared directory structure for any given team. With this in place, there is no hesitation on where to put data while working.
The package `pilotis_io.directory_structure` provides functions to help in building paths for any given file that should be stored in a data project :

- Raw data: usually text formatted files (CSV, JSON, ...) collected from some external system
- Parsed/cleaned data: the same as the previous raw files, but stored as binary file for efficiency and mayed with some cleaning performed.
- Generated datasets: datasets generated by a specific use case (like prepared features for a ML model)
- Models: the trained ML models for a specific use case
- Exports: datasets generated by a specific use case for an external use

All provided paths here are relative paths to somewhere a data directory structure resides.

Persistences
============

Working as a glue for the 2 previous features, persistences are classes that could be used to deal with framework specific files.

Availablle persistence classes :
- `pilotis_io.peresistence.LandingDataSourcePersistence`: parse CSV (from raw data directory) or Parquet (from parsed data directory) files as Pandas dataframes
- `pilotis_io.peresistence.UseCaseDataSetPersistence`: read/write datasets for a specific UseCase
- `pilotis_io.peresistence.UseCaseModelPersistence`: read/write machine learning models for a specific UseCase
- `pilotis_io.peresistence.UseCaseExportPersistence`: read/write CSV exports for a specific UseCase

Framework Specific APIs
=======================

There are abstract classes for using some basic frameworks like Pandas (`pilotis_io.pandas.PandasApi`) or Numpy (`pilotis_io.numpy.NumpyApi`).
There are currently 2 implementations for each:

- Local : to be used with the LocalIoApi
- S3 : to be used with the S3IoApi

Examples
========

Loading a raw CSV file from the local file system

.. code-block:: python
   from pilotis_io.local import LocalIoApi, LocalPandasApi
   from pilotis_io.directory_structure import dataset_raw_dir_path

   project_dir = "/path/to/project"
   io_api = LocalIoApi(project_dir)
   pandas_api = LocalPandasApi(io_api)

   csv_file = dataset_raw_dir_path(
    dataset_name="my_dataset",
    dataset_version="2020_01_01"
    ) / "my_file.csv"
   my_dataframe = pandas_api.load_pandas_dataset([csv], sep=";")


Credits
-------

This package was created with Cookiecutter_ and the
`opinionated-digital-center/python-library-project-generator`_ project template.

.. _Cookiecutter: https://github.com/audreyr/cookiecutter
.. _`opinionated-digital-center/python-library-project-generator`: https://github.com/opinionated-digital-center/python-library-project-generator
